# -*- coding: utf-8 -*-
"""
Nachweise Holz
Dipl.-Ing. (FH) Heiko Lüttich
Stand: 2022-07-25
"""
### Bemessung eines Druckstabes + Doppelbiegung
#importieren der Module
import MatHolz
import HolzNW
import QuerWert

#Funktionen
def bem_Wert(kmod,Wert,Gamma):
    b_Wert = kmod * Wert/Gamma
    return b_Wert

def km_Wert(b,h):
    v_wert = float(h/b)
    if v_wert <= 4:
        km = 0.7
    else:
        km = 1.0
    return km

#statische Werte
Gamma_M = 1.30

### Hauptprogramm ###
#Abfrage der Querschnitts- und Systemgrößen
abfrage_Prog = int(1)
while abfrage_Prog == 1:
    print("Bemessung Holz - ")
    print("Druck mit")
    print("Doppelbiegeung")
    print("=================")
    print("")
    print("Querschnitt|System")
    print("------------------")
    stat_Laenge = float(input("Laenge [m]: "))
    beta_BK = float(input("beta (BK): "))
    b_Quer = float(input("Breite b,y [cm]: "))
    h_Quer = float(input("Hoehe h,z [cm]: "))
    print("")
    a_Quer = QuerWert.a_Flaeche(b_Quer, h_Quer)
    print("A,ef = ", a_Quer, " cm2")
    wy_Quer = QuerWert.w_Quer(b_Quer, h_Quer)
    print("W,y = ", round(wy_Quer, 2)," cm3")
    wz_Quer = QuerWert.w_Quer(h_Quer, b_Quer)
    print("W,z = ", round(wz_Quer, 2)," cm3")
    km = km_Wert(b_Quer, h_Quer)
    print("k,m-Wert: ", round(km, 2))
    print("press EXE")
    input("")
    Iy_Grad2 = QuerWert.I_Traeg_Grad2(b_Quer, h_Quer)
    print("Iy = ", round(Iy_Grad2, 2), " cm4")
    Iz_Grad2 = QuerWert.I_Traeg_Grad2(h_Quer, b_Quer)
    print("Iz = ", round(Iz_Grad2, 2), " cm4")
    iy_Rad = QuerWert.i_Radius(Iy_Grad2, a_Quer)
    print("i,y = ",round(iy_Rad, 3), " cm")
    iz_Rad = QuerWert.i_Radius(Iz_Grad2, a_Quer)
    print("i,z = ", round(iz_Rad, 3), " cm")
    print("press EXE")
    input("")
    
    #Abfrage der Beanspruchungen
    print("Beanspruchung")
    print("(Bemessung mit")
    print("Absolutwerten):")
    print("---------------")
    Fcxd = float(input("N,d [kN]: "))
    Myd = float(input("My,d [kNm]: "))
    Mzd = float(input("Mz,d [kNm]: "))
    print("")
    print("zweiachsig + BK:")
    kmod_2 = float(input("k,mod: "))
    print("")
    sigma_Cd = abs(float(HolzNW.druck_N(Fcxd, a_Quer)))
    print("|Sigma,c,d|= ", round(sigma_Cd, 2), "N/mm2")
    sigma_Myd = abs(float(HolzNW.bieg_M(Myd, wy_Quer)))
    print("|Sigma,m,y,d|= ", round(sigma_Myd, 2)," N/mm2")
    sigma_Mzd = abs(float(HolzNW.bieg_M(Mzd, wz_Quer)))
    print("|Sigma,m,z,d|= ", round(sigma_Mzd,2), "N/mm2")
    print("press EXE")
    input("")
    
    #Abfrage der Holzsorte und -güte
    uebergabe_Mat = MatHolz.abfrage_Holz()
    # print(uebergabe_Mat)
    uebergabe_Index_Mat = uebergabe_Mat[0]
    # print(uebergabe_Index_Mat)
    # print("")
    print("erforderliche")
    print("Kennwerte:")
    print("-------------")
    print("press EXE")
    input("")
    if uebergabe_Index_Mat == 0:
        roh_VH = uebergabe_Mat[12]
        print("roh = ", roh_VH)
        kh_Bieg = float(HolzNW.kh_WertVH(h_Quer, roh_VH))
        print("k,h,Bieg = ", kh_Bieg)
        fc0k = uebergabe_Mat[4]
        print("f,c,0,k = ", fc0k, "N/mm2")
        fc0d = bem_Wert(kmod_2,fc0k,Gamma_M)
        print("f,c,0,d = ", round(fc0d, 2), "N/mm2")
        fmk = uebergabe_Mat[1]
        print("f,m,y,k = f,m,z,k = ", fmk, "N/mm2")
        fmd_2 = bem_Wert(kmod_2, fmk, Gamma_M)
        print("f,m,y,d = f,m,z,d =", round(fmd_2, 2), "N/mm2" )
        E_005 = uebergabe_Mat[9]
        print("E0,05 = ", E_005, "N/mm2")
        beta_C = uebergabe_Mat[14]
        print("Beta_C = ", beta_C)
    elif uebergabe_Index_Mat == 1:
        roh_VH = uebergabe_Mat[12]
        print("roh = ", roh_VH)
        kh_Bieg = float(HolzNW.kh_WertVH(h_Quer, roh_VH))
        print("k,h,Bieg = ", kh_Bieg)
        fc0k = uebergabe_Mat[4]
        print("f,c,0,k = ", fc0k, "N/mm2")
        fc0d = bem_Wert(kmod_2,fc0k,Gamma_M)
        print("f,c,0,d = ", round(fc0d, 2), "N/mm2")
        fmk = uebergabe_Mat[1]
        print("f,m,y,k = f,m,z,k = ", fmk, "N/mm2")
        fmd_2 = bem_Wert(kmod_2, fmk, Gamma_M)
        print("f,m,y,d = f,m,z,d =", round(fmd_2, 2), "N/mm2" )
        E_005 = uebergabe_Mat[9]
        print("E0,05 = ", E_005, "N/mm2")
        beta_C = uebergabe_Mat[14]
        print("Beta_C = ", beta_C)
    elif uebergabe_Index_Mat == 2:
        roh_BSH = uebergabe_Mat[16]
        print("roh = ", roh_BSH)
        kh_Bieg = float(HolzNW.kh_WertBSH(h_Quer))
        print("k,h,Bieg = ", kh_Bieg)
        fc0k = uebergabe_Mat[4]
        print("f,c,0,g,k = ", fc0k, "N/mm2")
        fc0d = bem_Wert(kmod_2,fc0k,Gamma_M)
        print("f,c,0,g,d = ", round(fc0d, 2), "N/mm2")
        fmk = uebergabe_Mat[1]
        print("f,m,y,g,k = f,m,z,g,k = ", fmk, "N/mm2")
        fmd_2 = bem_Wert(kmod_2, fmk, Gamma_M)
        print("f,m,y,g,d = f,m,z,g,d =", round(fmd_2, 2), "N/mm2" )
        E_005 = uebergabe_Mat[9]
        print("E0,g,05 = ", E_005, "N/mm2")
        beta_C = uebergabe_Mat[18]
        print("Beta_C = ", beta_C)
    print("press EXE")
    input("")
    #Nachweise der Querschnittstragfähigkeit
    print("Nachweis (NW)")
    print("Querschnitts-")
    print("tragfaehigkeit")
    print("==============")
    print("press EXE")
    input("")
    print("Nachweis -N|M,y|M,z:")
    print("--------------------")
    eta_NW = HolzNW.zwei_BiegDruck(abs(sigma_Cd), fc0d, sigma_Myd, fmd_2, sigma_Mzd, fmd_2, km, kh_Bieg)
    print("eta,y = ",round(eta_NW[0],3))
    HolzNW.vergleich(eta_NW[0])
    print("eta,z = ",round(eta_NW[1],3))
    HolzNW.vergleich(eta_NW[1])
    
    #Nachweis Stabilität
    print("Nachweis (NW)")
    print("Stabilitaet")
    print("============")
    print("press EXE")
    input("")
    print("Ersatzstab-")
    print("laenge:")
    l_EF = HolzNW.l_ef(beta_BK, stat_Laenge)
    print("l,ef = ", round(l_EF, 2), " m")
    print("press Exe")
    input("")
    print("")
    print("Schlankheits-")
    print("grad:")
    lambda_y = HolzNW.lamda(l_EF, iy_Rad)
    print("lambda, y = ", round(lambda_y, 3))
    lambda_z = HolzNW.lamda(l_EF, iz_Rad)
    print("lambda, z = ", round(lambda_z, 3))
    print("")
    print("press Exe")
    input("")
    print("bezogene")
    print("Schlankheit:")
    lambda_rel_y = HolzNW.lambda_Rel(lambda_y, fc0k, E_005)
    print("lambda,rel,y = ", round(lambda_rel_y, 3))
    lambda_rel_z = HolzNW.lambda_Rel(lambda_z, fc0k, E_005)
    print("lambda,rel,z = ", round(lambda_rel_z, 3))
    print("")
    print("press Exe")
    input("")
    print("Formelbeiwert:")
    k_Formel_y = HolzNW.k_Formel(beta_C, lambda_rel_y)
    print("k,y = ", round(k_Formel_y, 3))
    k_Formel_z = HolzNW.k_Formel(beta_C, lambda_rel_z)
    print("k,z = ", round(k_Formel_z, 3))
    print("")
    print("press Exe")
    input("")
    print("Knickbeiwert:")
    k_CY = HolzNW.kc_Knick(k_Formel_y, lambda_rel_y)
    print("kc,y = ", round(k_CY,3))
    k_CZ = HolzNW.kc_Knick(k_Formel_z, lambda_rel_z)
    print("kc,z = ", round(k_CZ, 3))
    print("")
    print("press Exe")
    input("")
    print("Nachweis Biegeknicken")
    print("---------------------")
    print("press EXE")
    input("")
    eta_BK = HolzNW.biege_Knick(sigma_Cd, fc0d, k_CY, k_CZ, sigma_Myd, fmd_2, sigma_Mzd, fmd_2, km, kh_Bieg)
    print("eta,y (BK) = ",round(eta_BK[0],3))
    HolzNW.vergleich(eta_BK[0])
    print("eta,z (BK) = ",round(eta_BK[1],3))
    HolzNW.vergleich(eta_BK[1])
    print("Bemessung neu = [1]")
    print("Ende = [2]")
    abfrage_Prog = int(input("Auswahl:"))
print("")
print("Programmende")