# -*- coding: utf-8 -*-
"""
Nachweise Holz
Dipl.-Ing. (FH) Heiko Lüttich
Stand: 2022-12-07
"""
### Spannungsnachweise
#importieren der Module
import MatHolz
import HolzNW
import QuerWert
#Funktionen
def bem_Wert(kmod,Wert,Gamma):
    b_Wert = kmod * Wert/Gamma
    return b_Wert
def km_Wert(b,h):
    v_wert = float(h/b)
    if v_wert <= 4:
        km = 0.7
    else:
        km = 1.0
    return km
#statische Werte
Gamma_M = 1.30
### Hauptprogramm ###
#Abfrage der Querschnitts- und Systemgrößen
abfrage_Prog = int(1)
while abfrage_Prog == 1:    
    print("Bemessung Holz - ")
    print("Spannungsnachweis")
    print("=================")
    print("")
    print("Querschnitt|System")
    print("------------------")
    b_Quer = float(input("Breite b,y [cm]: "))
    h_Quer = float(input("Hoehe h,z [cm]: "))
    print("")
    a_Quer = QuerWert.a_Flaeche(b_Quer, h_Quer)
    print("A,quer = ", a_Quer, " cm2")
    wy_Quer = QuerWert.w_Quer(b_Quer, h_Quer)
    print("W,y = ", round(wy_Quer, 2)," cm3")
    wz_Quer = QuerWert.w_Quer(h_Quer, b_Quer)
    print("W,z = ", round(wz_Quer, 2)," cm3")
    km = km_Wert(b_Quer, h_Quer)
    print("k,m-Wert: ", round(km, 2))
    print("press EXE")
    input("")
    Iy_Grad2 = QuerWert.I_Traeg_Grad2(b_Quer, h_Quer)
    print("Iy = ", round(Iy_Grad2, 2), " cm4")
    Iz_Grad2 = QuerWert.I_Traeg_Grad2(h_Quer, b_Quer)
    print("Iz = ", round(Iz_Grad2, 2), " cm4")
    iy_Rad = QuerWert.i_Radius(Iy_Grad2, a_Quer)
    print("i,y = ",round(iy_Rad, 3), " cm")
    iz_Rad = QuerWert.i_Radius(Iz_Grad2, a_Quer)
    print("i,z = ", round(iz_Rad, 3), " cm")
    print("press EXE")
    input("")
    #Abfrage der Beanspruchungen
    print("Beanspruchung")
    print("(Bemessung mit")
    print("Absolutwerten):")
    print("und Druck negativ")
    print("---------------")
    Fcxd = float(input("N,d [kN]: "))
    Myd = float(input("My,d [kNm]: "))
    Mzd = float(input("Mz,d [kNm]: "))
    Vzd = float(input("Vz,d [kN]: "))
    Vyd = float(input("Vy,d [kN]: "))
    print("")
    kmod_2 = float(input("k,mod: "))
    print("")
    #Abfrage der Holzsorte und -güte
    uebergabe_Mat = MatHolz.abfrage_Holz()
    # print(uebergabe_Mat)
    uebergabe_Index_Mat = uebergabe_Mat[0]
    print("erforderliche")
    print("Kennwerte:")
    print("-------------")
    print("press EXE")
    input("")
    if uebergabe_Index_Mat == 0:
        roh_VH = uebergabe_Mat[12]
        print("roh = ", roh_VH)
        kh_Bieg = HolzNW.kh_WertVH(h_Quer, roh_VH)
        print("k,h,Bieg = ", kh_Bieg)
        kh_Zug = HolzNW.kh_WertVH(max(b_Quer, h_Quer), roh_VH)
        print("k,h,Zug = ", kh_Zug)
        fc0k = uebergabe_Mat[4]
        print("f,c,0,k = ", fc0k, "N/mm2")
        fc0d = bem_Wert(kmod_2,fc0k,Gamma_M)
        print("f,c,0,d = ", round(fc0d, 2), "N/mm2")
        ft0k = uebergabe_Mat[2]
        print("f,t,0,k = ", ft0k, "N/mm²")
        ft0d = bem_Wert(kmod_2, ft0k, Gamma_M)
        print("f,t,0,d = ", round(ft0d, 2), "N/mm²")
        fmk = uebergabe_Mat[1]
        print("f,m,y,k = f,m,z,k = ", fmk, "N/mm2")
        fmd_2 = bem_Wert(kmod_2, fmk, Gamma_M)
        print("f,m,y,d = f,m,z,d =", round(fmd_2, 2), "N/mm2" )
        fvk = uebergabe_Mat[6]
        print("f,v,k = ", fvk, "N/mm²")
        fvd = bem_Wert(kmod_2, fvk, Gamma_M)
        print("f,v,d = ", round(fvd, 2), "N/mm2")
        kcr = 2.0 / fvk
        print("k,c,r um 30% erhoehen?")
        print("Ja = [0]")
        print("Nein = [1]")
        kcr_Erh = int(input("Erhoehung:"))
        if kcr_Erh == 0:
            kcr = kcr * 1.3
            print("k,c,r = ", round(kcr,3))
        elif kcr_Erh == 1:
            kcr = kcr*1.0
            print("k,c,r = ", round(kcr,3))
    elif uebergabe_Index_Mat == 1:
        roh_VH = uebergabe_Mat[12]
        print("roh = ", roh_VH)
        kh_Bieg = HolzNW.kh_WertVH(h_Quer, roh_VH)
        print("k,h,Bieg = ", kh_Bieg)
        kh_Zug = HolzNW.kh_WertVH(max(b_Quer, h_Quer), roh_VH)
        print("k,h,Zug = ", kh_Zug)
        fc0k = uebergabe_Mat[4]
        print("f,c,0,k = ", fc0k, "N/mm2")
        fc0d = bem_Wert(kmod_2,fc0k,Gamma_M)
        print("f,c,0,d = ", round(fc0d, 2), "N/mm2")
        ft0k = uebergabe_Mat[2]
        print("f,t,0,k = ", ft0k, "N/mm²")
        ft0d = bem_Wert(kmod_2, ft0k, Gamma_M)
        print("f,t,0,d = ", round(ft0d, 2), "N/mm²")
        fmk = uebergabe_Mat[1]
        print("f,m,y,k = f,m,z,k = ", fmk, "N/mm2")
        fmd_2 = bem_Wert(kmod_2, fmk, Gamma_M)
        print("f,m,y,d = f,m,z,d =", round(fmd_2, 2), "N/mm2" )
        fvk = uebergabe_Mat[6]
        print("f,v,k = ", fvk, "N/mm²")
        fvd = bem_Wert(kmod_2, fvk, Gamma_M)
        print("f,v,d = ", round(fvd, 2), "N/mm2")
        kcr = 0.67
        print("k,c,r = ", round(kcr,3))    
    elif uebergabe_Index_Mat == 2:
        roh_BSH = uebergabe_Mat[16]
        print("roh = ", roh_BSH)
        kh_Bieg = HolzNW.kh_WertBSH(h_Quer)
        print("k,h,Bieg = ", kh_Bieg)
        kh_Zug = HolzNW.kh_WertBSH(max(b_Quer, h_Quer))
        print("k,h,Zug = ", kh_Zug)
        fc0k = uebergabe_Mat[4]
        print("f,c,0,g,k = ", fc0k, "N/mm2")
        fc0d = bem_Wert(kmod_2,fc0k,Gamma_M)
        print("f,c,0,g,d = ", round(fc0d, 2), "N/mm2")
        ft0k = uebergabe_Mat[2]
        print("f,t,0,g,k = ", ft0k, "N/mm²")
        ft0d = bem_Wert(kmod_2, ft0k, Gamma_M)
        print("f,t,0,g,d = ", round(ft0d, 2), "N/mm²")
        fmk = uebergabe_Mat[1]
        print("f,m,y,g,k = f,m,z,g,k = ", fmk, "N/mm2")
        fmd_2 = bem_Wert(kmod_2, fmk, Gamma_M)
        print("f,m,y,g,d = f,m,z,g,d =", round(fmd_2, 2), "N/mm2" )
        fvk = uebergabe_Mat[6]
        print("f,v,g,k = ", fvk, "N/mm²")
        fvd = bem_Wert(kmod_2, fvk, Gamma_M)
        print("f,v,d = ", round(fvd, 2), "N/mm2")
        kcr = 2.5 / fvk
        print("k,c,r = ", round(kcr,3))    
    print("press EXE")
    input("")
    #Bemessungsspannungen / Designwerte
    sigma_Cd = abs(float(HolzNW.druck_N(Fcxd, a_Quer)))
    print("|Sigma,c,d|= ", round(sigma_Cd, 2), "N/mm2")
    sigma_Myd = abs(float(HolzNW.bieg_M(Myd, wy_Quer)))
    print("|Sigma,m,y,d|= ", round(sigma_Myd, 2)," N/mm2")
    sigma_Mzd = abs(float(HolzNW.bieg_M(Mzd, wz_Quer)))
    print("|Sigma,m,z,d|= ", round(sigma_Mzd,2), "N/mm2")
    print("press EXE")
    input("")
    a_EffY = HolzNW.a_Eff(b_Quer, h_Quer, kcr)
    print("A,eff,y = ", round(a_EffY, 2), "cm2")
    tau_YD = abs(float(HolzNW.schub_V(Vyd, a_EffY)))
    print("|Tau,y,d| = ", round(tau_YD, 2), "N/mm2")
    a_EffZ = HolzNW.a_Eff(h_Quer, b_Quer, kcr)
    print("A,eff,z = ", round(a_EffZ, 2), "cm2")
    tau_ZD = abs(float(HolzNW.schub_V(Vzd, a_EffZ)))
    print("|Tau,z,d| = ", round(tau_ZD, 2), "N/mm2")
    print("press EXE")
    input("")
    #Nachweise der Querschnittstragfähigkeit
    print("Nachweis (NW)")
    print("Querschnitts-")
    print("tragfaehigkeit")
    print("==============")
    print("press EXE")
    input("")
    print("Nachweis N|M,y|M,z:")
    print("--------------------")
    if Fcxd < 0:
        if Myd == 0 and Mzd == 0:
            eta_NW = round(HolzNW.druck_ND(abs(sigma_Cd), fc0d), 3)
            print("Druck ohne")
            print("Biegung")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) > 0 and abs(Mzd) == 0:
            eta_NW = round(HolzNW.ein_BiegDruck(abs(sigma_Cd), fc0d, sigma_Myd, fmd_2, kh_Bieg), 3)
            print("Druck mit")
            print("Biegung M,y")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) == 0 and abs(Mzd) > 0:
            eta_NW = round(HolzNW.ein_BiegDruck(abs(sigma_Cd), fc0d, sigma_Mzd, fmd_2, 1.0), 3)
            print("Druck mit")
            print("Biegung M,z")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) > 0 and abs(Mzd) > 0:        
            eta_NW = HolzNW.zwei_BiegDruck(abs(sigma_Cd), fc0d, sigma_Myd, fmd_2, sigma_Mzd, fmd_2, km, kh_Bieg)
            print("Druck mit")
            print("Doppelbiegung")
            print("eta,y = ",round(eta_NW[0],3))
            HolzNW.vergleich(eta_NW[0])
            print("eta,z = ",round(eta_NW[1],3))
            HolzNW.vergleich(eta_NW[1])
    elif Fcxd > 0:
        if Myd == 0 and Mzd == 0:
            eta_NW = round(HolzNW.zug_ND(abs(sigma_Cd), ft0d, kh_Zug), 3)
            print("Zug ohne")
            print("Biegung")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) > 0 and abs(Mzd) == 0:
            eta_NW = round(HolzNW.ein_BiegZug(abs(sigma_Cd), ft0d, sigma_Myd, fmd_2, kh_Zug, kh_Bieg), 3)
            print("Zug mit")
            print("Biegung M,y")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) == 0 and abs(Mzd) > 0:
            eta_NW = round(HolzNW.ein_BiegZug(abs(sigma_Cd), ft0d, sigma_Mzd, fmd_2, kh_Zug, 1.0), 3)
            print("Zug mit")
            print("Biegung M,z")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) > 0 and abs(Mzd) > 0:        
            eta_NW = HolzNW.zwei_BiegZug(abs(sigma_Cd), ft0d, sigma_Myd, fmd_2, sigma_Mzd, fmd_2, km, kh_Zug, kh_Bieg)
            print("Zug mit")
            print("Doppelbiegung")
            print("eta,y = ",round(eta_NW[0],3))
            HolzNW.vergleich(eta_NW[0])
            print("eta,z = ",round(eta_NW[1],3))
            HolzNW.vergleich(eta_NW[1])
            print("")
    elif Fcxd == 0:
        if Myd == 0 and Mzd == 0:
            print("kein Nachweis")
            print("press EXE")
            input("")
        elif abs(Myd) > 0 and abs(Mzd) == 0:
            eta_NW = round(HolzNW.ein_BiegZug(abs(sigma_Cd), ft0d, sigma_Myd, fmd_2, kh_Zug, kh_Bieg), 3)
            print("Biegung M,y")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) == 0 and abs(Mzd) > 0:
            eta_NW = round(HolzNW.ein_BiegZug(abs(sigma_Cd), ft0d, sigma_Mzd, fmd_2, kh_Zug, 1.0), 3)
            print("Biegung M,z")
            print("eta = ", eta_NW)
            HolzNW.vergleich(eta_NW)
        elif abs(Myd) > 0 and abs(Mzd) > 0:        
            eta_NW = HolzNW.zwei_BiegZug(abs(sigma_Cd), ft0d, sigma_Myd, fmd_2, sigma_Mzd, fmd_2, km, kh_Zug, kh_Bieg)
            print("Doppelbiegung")
            print("eta,y = ",round(eta_NW[0],3))
            HolzNW.vergleich(eta_NW[0])
            print("eta,z = ",round(eta_NW[1],3))
            HolzNW.vergleich(eta_NW[1])
    print("Nachweis V,y|V,z:")
    print("-----------------")
    if abs(Vyd) > 0 and Vzd == 0:
        print("einachsig, V,y,d:")
        eta_NWvy = HolzNW.tau_SchubEins(tau_YD, fvd)
        print("eta (V,y) = ", round(eta_NWvy, 2))
        HolzNW.vergleich(eta_NWvy)
    elif Vyd == 0 and abs(Vzd) > 0:
        print ("einachsig Vz,d:")
        eta_NWvz = HolzNW.tau_SchubEins(tau_ZD, fvd)
        print("eta (V,z) = ", round(eta_NWvz, 2))
        HolzNW.vergleich(eta_NWvz)
    elif abs(Vyd) > 0 and abs(Vzd) > 0:
        print("zweiachsig V,y,d|V,z,d:")
        eta_NWvy = HolzNW.tau_SchubEins(tau_YD, fvd)
        print("eta (V,y) = ", round(eta_NWvy, 2))
        eta_NWvz = HolzNW.tau_SchubEins(tau_ZD, fvd)
        print("eta (V,z) = ", round(eta_NWvz, 2))        
        eta_NWVyz = (eta_NWvy**2) + (eta_NWvz**2)
        print("eta (V,y|V,z) = ", round(eta_NWVyz, 2))
        HolzNW.vergleich(eta_NWVyz)
    elif Vyd == 0 and Vzd == 0:
        print("Kein Schubnachweis!")
    print("Bemessung neu = [1]")
    print("Ende = [2]")
    abfrage_Prog = int(input("Auswahl:"))
print("")
print("Programmende")