# -*- coding: utf-8 -*-
"""
Materialkennwerte Holz
Dipl.-Ing. (FH) Heiko Lüttich
Stand: 2022-07-25
"""

### Ausgangswerte ###
#Definition der Festigkeitsklassen Nadelholz
fk_Klassen_NH = ("C16", "C18", "C24", "C30", "C35")
fk_Klassen_LH = ("D30", "D35", "D40", "D60")
fk_Klassen_BSH = ("GL24c", "GL28c", "GL30c", "GL32c", "GL24h", "GL28h", "GL30h", "GL32h")

#Definition der Kennwerte für Nadelholz in [N/mm²] und kg/m³
fkw_fmk_NH = (16, 18, 24, 30, 35)                  #Biegung fm,k
fkw_ft0k_NH = (8.5, 10, 14.5, 19, 22.5)            #Zug parallel ft,0,k
fkw_ft90k_NH = (0.4, 0.4, 0.4, 0.4, 0.4)           #Zug rechtwinklig ft,90,k
fkw_fc0k_NH = (17, 18, 21, 24, 25)                 #Druck parallel fc,0,k
fkw_fc90k_NH = (2.2, 2.2, 2.5, 2.7, 2.7)           #Druck rechtwinklig fc,90,k
fkw_fvk_NH = (3.2, 3.4, 4.0, 4.0, 4.0)             #Schub/Torsion fv,k
fkw_fRk_NH = (0.8, 0.8, 0.8, 0.8, 0.8)             #Rollschub fR,k
skw_E0mean_NH = (8000, 9000, 11000, 12000, 13000)  #E-Modul parallel E0,mean
skw_E05_NH = (5400, 6000, 7400, 8000, 8700)        #E-Modul parallel E0,05
skw_E90mean_NH = (270, 300, 370, 400, 430)         #E-Modul rechtwinklig E90,mean
skw_Gmean_NH = (500, 560, 690, 750, 810)           #Schubmodul Gmean
rkw_rohk_NH = (310, 320, 350, 380, 390)            #Rohdichte roh,k
rkw_rohmean_NH = (370, 380, 420, 460, 470)         #Rohdichte roh,mean

#Definition der Kennwerte für Laubholz in [N/mm²] und kg/m³
fkw_fmk_LH = (30, 35, 40, 60)                  #Biegung fm,k
fkw_ft0k_LH = (18, 21, 24, 36)            #Zug parallel ft,0,k
fkw_ft90k_LH = (0.6, 0.6, 0.6, 0.6)           #Zug rechtwinklig ft,90,k
fkw_fc0k_LH = (24, 25, 27, 33)                 #Druck parallel fc,0,k
fkw_fc90k_LH = (5.3, 5.4, 5.5, 10.5)           #Druck rechtwinklig fc,90,k
fkw_fvk_LH = (3.9, 4.1, 4.2, 4.8)             #Schub/Torsion fv,k
fkw_fRk_LH = (0, 0, 0, 0)                           #Rollschub fR,k gibt es hier nicht
skw_E0mean_LH = (11000, 12000, 13000, 17000)  #E-Modul parallel E0,mean
skw_E05_LH = (9200, 10100, 10900, 14300)        #E-Modul parallel E0,05
skw_E90mean_LH = (730, 800, 870, 1130)         #E-Modul rechtwinklig E90,mean
skw_Gmean_LH = (690, 750, 810, 1060)           #Schubmodul Gmean
rkw_rohk_LH = (530, 540, 550, 700)            #Rohdichte roh,k
rkw_rohmean_LH = (640, 650, 660, 840)         #Rohdichte roh,mean

#Definition der Kennwerte für Brettschichtholz in [N/mm²] und kg/m³
fkw_fmgk_BSH = (24, 28, 30, 32, 24, 28, 30, 32)                  #Biegung fm,g,k
fkw_ft0gk_BSH = (17, 19.5, 19.5, 19.5, 19.2, 22.3, 24, 25.6)            #Zug parallel ft,0,g,k
fkw_ft90gk_BSH = (0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5, 0.5)           #Zug rechtwinklig ft,90,g,k
fkw_fc0gk_BSH = (21.5, 24, 24.5, 24.5, 24, 28, 30, 32)                 #Druck parallel fc,0,g,k
fkw_fc90gk_BSH = (2.5, 2.5, 2.5, 2.5, 2.5, 2.5, 2.5, 2.5)           #Druck rechtwinklig fc,90,g,k
fkw_fvgk_BSH = (3.5, 3.5, 3.5, 3.5, 3.5, 3.5, 3.5, 3.5)             #Schub/Torsion fv,g,k
fkw_fRgk_BSH = (1.2, 1.2, 1.2, 1.2, 1.2, 1.2, 1.2, 1.2)              #Rollschub fR,g,k
skw_E0gmean_BSH = (11000, 12500, 13000, 13500, 1500, 12600, 13600, 14200)  #E-Modul parallel E0,g,mean
skw_E05g_BSH = (9100, 10400, 10800, 11200, 9600, 10500, 11300, 11800)        #E-Modul parallel E0,g,05
skw_E90gmean_BSH = (300, 300, 300, 300, 300, 300, 300, 300)         #E-Modul rechtwinklig E90,g,mean
skw_E90g05_BSH = (250, 250, 250, 250, 250, 250, 250, 250)           #E-Modul rechtwinklig E90g,05
skw_Ggmean_BSH = (650, 650, 650, 650, 650, 650, 650, 650)           #Schubmodul G,g,mean
skw_Gg05_BSH = (540, 540, 540, 540, 540, 540, 540, 540)           #Schubmodul G,g,05
skw_Grgmean_BSH = (65, 65, 65, 65, 65, 65, 65, 65)                  #Rollschubmodul G,r,g,mean
skw_Grg05_BSH = (54, 54, 54, 54, 54, 54, 54, 54)                  #Rollschubmodul G,r,g,05
rkw_rohgk_BSH = (365, 390, 390, 400, 385, 425, 430, 440)            #Rohdichte roh,k
rkw_rohgmean_BSH = (400, 420, 430, 440, 420, 460, 480, 490)         #Rohdichte roh,mean

def abfrage_Holz():
    mat_Klassen = ("NH", "LH", "BSH")
    print("Waehle Material:")
    for a in range(0, len(mat_Klassen)):
        print("[", a, "]", mat_Klassen[a])

    fk_index_mat = int(input("Material:"))

    uebergabe_Liste = []

    if fk_index_mat == 0:
        # uebergabe_Liste = []
        index_mat = 0
        uebergabe_Liste.append(index_mat)
        print("moegliche Sorten:")
        for n in range(0, len(fk_Klassen_NH)):
            print("[", n, "]", fk_Klassen_NH[n])
        fk_index_NH = int(input("Waehle Sorte:"))
        print("gewaehlte: ", fk_Klassen_NH[fk_index_NH])
        print("Materialkennwerte:")
        print("fm,k = ",fkw_fmk_NH[fk_index_NH])
        uebergabe_Liste.append(fkw_fmk_NH[fk_index_NH])
        print("ft,0,k = ",fkw_ft0k_NH[fk_index_NH])
        uebergabe_Liste.append(fkw_ft0k_NH[fk_index_NH])
        print("ft,90,k = ",fkw_ft90k_NH[fk_index_NH])
        uebergabe_Liste.append(fkw_ft90k_NH[fk_index_NH])
        print("fc,0,k = ",fkw_fc0k_NH[fk_index_NH])
        uebergabe_Liste.append(fkw_fc0k_NH[fk_index_NH])
        print("fc,90,k = ",fkw_fc90k_NH[fk_index_NH])
        uebergabe_Liste.append(fkw_fc90k_NH[fk_index_NH])
        print("fv,k = ",fkw_fvk_NH[fk_index_NH])
        uebergabe_Liste.append(fkw_fvk_NH[fk_index_NH])
        print("fR,k = ",fkw_fRk_NH[fk_index_NH])           #nur bei NH und BSH
        uebergabe_Liste.append(fkw_fRk_NH[fk_index_NH])
        print("E0,mean = ",skw_E0mean_NH[fk_index_NH])
        uebergabe_Liste.append(skw_E0mean_NH[fk_index_NH])
        print("E0,05 = ",skw_E05_NH[fk_index_NH])
        uebergabe_Liste.append(skw_E05_NH[fk_index_NH])
        print("E90,mean = ",skw_E90mean_NH[fk_index_NH])
        uebergabe_Liste.append(skw_E90mean_NH[fk_index_NH])
        print("Gmean = ",skw_Gmean_NH[fk_index_NH])
        uebergabe_Liste.append(skw_Gmean_NH[fk_index_NH])
        print("roh,k = ",rkw_rohk_NH[fk_index_NH])
        uebergabe_Liste.append(rkw_rohk_NH[fk_index_NH])
        print("roh,mean = ",rkw_rohmean_NH[fk_index_NH])
        uebergabe_Liste.append(rkw_rohmean_NH[fk_index_NH])
        beta_C = 0.2
        print("Beta_C = ", beta_C)
        print("")
        uebergabe_Liste.append(beta_C)
        # uebergabe_Mat = fk_Klassen_NH[fk_index_NH]
        # uebergabe_Index = fk_index_NH
    elif fk_index_mat == 1:
        index_mat = 1
        uebergabe_Liste.append(index_mat)
        print("moegliche Sorten:")
        for n in range(0, len(fk_Klassen_LH)):
            print("[",n,"]", fk_Klassen_LH[n])
        fk_index_LH = int(input("Waehle Sorte:"))
        print("gewaehlt: ", fk_Klassen_LH[fk_index_LH])
        print("Materialkennwerte:")
        print("fm,k = ",fkw_fmk_LH[fk_index_LH])
        uebergabe_Liste.append(fkw_fmk_LH[fk_index_LH])
        print("ft,0,k = ",fkw_ft0k_LH[fk_index_LH])
        uebergabe_Liste.append(fkw_ft0k_LH[fk_index_LH])
        print("ft,90,k = ",fkw_ft90k_LH[fk_index_LH])
        uebergabe_Liste.append(fkw_ft90k_LH[fk_index_LH])
        print("fc,0,k = ",fkw_fc0k_LH[fk_index_LH])
        uebergabe_Liste.append(fkw_fc0k_LH[fk_index_LH])
        print("fc,90,k = ",fkw_fc90k_LH[fk_index_LH])
        uebergabe_Liste.append(fkw_fc90k_LH[fk_index_LH])
        print("fv,k = ",fkw_fvk_LH[fk_index_LH])
        uebergabe_Liste.append(fkw_fvk_LH[fk_index_LH])
        print("fR,k = ",fkw_fRk_LH[fk_index_LH])           #nur bei NH und BSH
        uebergabe_Liste.append(fkw_fRk_LH[fk_index_LH])
        print("E0,mean = ",skw_E0mean_LH[fk_index_LH])
        uebergabe_Liste.append(skw_E0mean_LH[fk_index_LH])
        print("E0,05 = ",skw_E05_LH[fk_index_LH])
        uebergabe_Liste.append(skw_E05_LH[fk_index_LH])
        print("E90,mean = ",skw_E90mean_LH[fk_index_LH])
        uebergabe_Liste.append(skw_E90mean_LH[fk_index_LH])
        print("Gmean = ",skw_Gmean_LH[fk_index_LH])
        uebergabe_Liste.append(skw_Gmean_LH[fk_index_LH])
        print("roh,k = ",rkw_rohk_LH[fk_index_LH])
        uebergabe_Liste.append(rkw_rohk_LH[fk_index_LH])
        print("roh,mean = ",rkw_rohmean_LH[fk_index_LH])
        uebergabe_Liste.append(rkw_rohmean_LH[fk_index_LH])
        beta_C = 0.2
        print("Beta_C = ", beta_C)
        print("")
        uebergabe_Liste.append(beta_C)
        # uebergabe_Mat = fk_Klassen_LH[fk_index_LH]
        # uebergabe_Index = fk_index_LH
    elif fk_index_mat == 2:
        index_mat = 2
        uebergabe_Liste.append(index_mat)
        print("moegliche Sorten:")
        for n in range(0, len(fk_Klassen_BSH)):
            print("[",n,"]", fk_Klassen_BSH[n])
            if n == 3:
                print("press EXE")
                input("")
        fk_index_BSH = int(input("Waehle Sorte:"))
        print("gewaehlt: ", fk_Klassen_BSH[fk_index_BSH])
        print("Materialkennwerte:")
        print("fm,g,k = ",fkw_fmgk_BSH[fk_index_BSH])
        uebergabe_Liste.append(fkw_fmgk_BSH[fk_index_BSH])
        print("ft,0,g,k = ",fkw_ft0gk_BSH[fk_index_BSH])
        uebergabe_Liste.append(fkw_ft0gk_BSH[fk_index_BSH])
        print("ft,90,g,k = ",fkw_ft90gk_BSH[fk_index_BSH])
        uebergabe_Liste.append(fkw_ft90gk_BSH[fk_index_BSH])
        print("fc,0,g,k = ",fkw_fc0gk_BSH[fk_index_BSH])
        uebergabe_Liste.append(fkw_fc0gk_BSH[fk_index_BSH])
        print("fc,90,g,k = ",fkw_fc90gk_BSH[fk_index_BSH])
        uebergabe_Liste.append(fkw_fc90gk_BSH[fk_index_BSH])
        print("fv,g,k = ",fkw_fvgk_BSH[fk_index_BSH])
        uebergabe_Liste.append(fkw_fvgk_BSH[fk_index_BSH])
        print("fR,g,k = ",fkw_fRgk_BSH[fk_index_BSH])           #nur bei NH und BSH
        uebergabe_Liste.append(fkw_fRgk_BSH[fk_index_BSH])
        print("E0,g,mean = ",skw_E0gmean_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_E0gmean_BSH[fk_index_BSH])
        print("E0,g,05 = ",skw_E05g_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_E05g_BSH[fk_index_BSH])
        print("E90g,,mean = ",skw_E90gmean_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_E90gmean_BSH[fk_index_BSH])
        print("E,90,g,05 = ", skw_E90g05_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_E90g05_BSH[fk_index_BSH])
        print("Gg,mean = ",skw_Ggmean_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_Ggmean_BSH[fk_index_BSH])
        print("G,05 = ",skw_Gg05_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_Gg05_BSH[fk_index_BSH])
        print("Gr,g,mean = ", skw_Grgmean_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_Grgmean_BSH[fk_index_BSH])
        print("Gr,g,05 = ", skw_Grg05_BSH[fk_index_BSH])
        uebergabe_Liste.append(skw_Grg05_BSH[fk_index_BSH])
        print("roh,g,k = ",rkw_rohgk_BSH[fk_index_BSH])
        uebergabe_Liste.append(rkw_rohgk_BSH[fk_index_BSH])
        print("roh,g,mean = ",rkw_rohgmean_BSH[fk_index_BSH])
        uebergabe_Liste.append(rkw_rohgmean_BSH[fk_index_BSH])
        beta_C = 0.1
        print("Beta_C = ", beta_C)
        print("")
        uebergabe_Liste.append(beta_C)
        # uebergabe_Mat = fk_Klassen_BSH[fk_index_BSH]
        # uebergabe_Index = fk_index_BSH
    return uebergabe_Liste
